/**
 * ITI 1220 Fall 2005, Assignment 6, Question 2
 * 
 * @author Alan Williams
 */

public class Frequency
{
	/**
	 * Count the number of occurrences of each lower case character in a string.
	 * <p>
	 * An array is returned where array index 0 represents the number of 'a'
	 * characters, array index 1 represents the number of 'b' characters, and so
	 * on up to array index 25 representing the number of 'z' characters.
	 * 
	 * @param text
	 *            A string for which to count occurrences of lower case letters.
	 * @return An array of integers, array length 26, representing the number of
	 *         occurrences of each letter in the text.
	 */
	
	public static int[] createFrequencyTable( String text )
	{
		int[] frequencies; 	// RESULT: table of character frequencies
		int index; 			// INTERMEDIATE: current location in message
		int charPosition; 	// INTERMEDIATE: character position in frequency
							// table
		char aChar; 		// INTERMEDIATE: current character
		
		// BODY OF ALGORITHM
		
		// Create result array, and initialize to all zeros.
		
		frequencies = new int[26];
		charPosition = 0;
		while ( charPosition < frequencies.length )
		{
			frequencies[charPosition] = 0;
			charPosition = charPosition + 1;
		}
		
		// For each character in message:
		
		index = 0;
		while ( index < text.length( ) )
		{
			// Get current character.
			
			aChar = text.charAt( index );
			
			// Check if we have a lower case letter.
			
			if ( aChar >= 'a' && aChar <= 'z' )
			{
				// Find relative difference between the character and 'a'.
				// This will be used as the array index in the frequency
				// table.
				//
				// Alternative: (int) aChar - (int) 'a'
				
				charPosition = aChar - 'a';
				
				// Add one to occurrences of this character.
				
				frequencies[charPosition] = frequencies[charPosition] + 1;
			}
			else
			{
				// Skip character
				
				; // do nothing
			}
				
			// Go to next letter in text.
			
			index = index + 1;
		}
		
		// RETURN RESULT
		
		return frequencies;
	}
}
