import junit.framework.Assert;
import junit.framework.TestCase;
/**
 * 
 */

/**
 * @author Alan Williams
 *
 */
public class CaesarTest extends TestCase
{

	public static void main( String[] args )
	{
		junit.swingui.TestRunner.run( CaesarTest.class );
	}

	/*
	 * Test method for 'Caesar.decode(String, int)'
	 * 
	 * Decode a message with shift 3.
	 */
	public void testDecode3( )
	{
		String data = "uhwxuq wr urph";

		String expected = "return to rome";
		String actual = Caesar.decode(data, 3);
		
		Assert.assertEquals( expected, actual );

	}

	/*
	 * Test method for 'Caesar.decode(String, int)'
	 * 
	 * See if decode with shift 0 has no effect.
	 */
	public void testDecode0( )
	{
		String data = "return to rome";

		String expected = "return to rome";
		String actual = Caesar.decode(data, 0);
		
		Assert.assertEquals( expected, actual );

	}
	/*
	 * Test method for 'Caesar.encode(String, int)'
	 * 
	 * Encode a message with shift 3.
	 */
	public void testEncode3( )
	{
		String data = "return to rome";

		String expected = "uhwxuq wr urph";
		String actual = Caesar.encode(data, 3);
		
		Assert.assertEquals( expected, actual );
	}

	/*
	 * Test method for 'Caesar.encode(String, int)'
	 * 
	 * Encode a message with shift 0.  Should leave message unchanged.
	 */
	public void testEncode0( )
	{
		String data = "return to rome";

		String expected = "return to rome";
		String actual = Caesar.encode(data, 0);
		
		Assert.assertEquals( expected, actual );
	}

	/*
	 * Test method for 'Caesar.encode(String, int)'
	 * 
	 * Encode a message with shift 25.  See if any problems
	 * happen with letters going past the end of the alphabet.
	 */
	public void testEncode25( )
	{
		String data = "return to rome";
	
		String expected = "qdstqm sn qnld";
		String actual = Caesar.encode(data, 25);
		
		Assert.assertEquals( expected, actual );
	}

	/*
	 * Test method for 'Caesar.decode(String, int)'
	 * 
	 * Decode a message with shift 25.  See if any problems
	 * happen with letters going past the end of the alphabet.
	 */
	public void testDecode25( )
	{
		String data = "qdstqm sn qnld";
	
		String expected = "return to rome";
		String actual = Caesar.decode(data, 25);
		
		Assert.assertEquals( expected, actual );
	
	}
}
